module ZprotectSDK;


version (D_InlineAsm_X86)
{

const Code_Confusion_START   = "asm { db 0xEB, 0x08, 0x53, 0x54, 0x5F, 0x53, 0x54, 0x41, 0x52, 0x54; }";
const Code_Confusion_END     = "asm { db 0xEB, 0x08, 0x53, 0x54, 0x5F, 0x53, 0x54, 0x45, 0x4E, 0x44; }";
                                    
const Code_Elimination_START = "asm { db 0xEB, 0x08, 0x4F, 0x43, 0x5F, 0x53, 0x54, 0x41, 0x52, 0x54; }";
const Code_Elimination_END   = "asm { db 0xEB, 0x08, 0x4F, 0x43, 0x5F, 0x4F, 0x43 ,0x45, 0x4E, 0x44; }";
                                    
const Decode_onExec_START    = "asm { db 0xEB, 0x08, 0x44, 0x59, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const Decode_onExec_END      = "asm { db xEB, 0x08, 0x44, 0x59, 0x5F, 0x44, 0x59 ,0x45, 0x4E, 0x44; }";

const Decode_onReg_START     = "asm { db 0xEB, 0x08, 0x52, 0x44, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const Decode_onReg_END       = "asm { db 0xEB, 0x08, 0x52, 0x44, 0x5F, 0x52, 0x44 ,0x45, 0x4E, 0x44; }";

const Decode_Section_A_START = "asm { db 0xEB, 0x08, 0x52, 0x31, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const Decode_Section_A_END   = "asm { db 0xEB, 0x08, 0x52, 0x31, 0x5F, 0x52, 0x44 ,0x45, 0x4E, 0x44; }";

const Decode_Section_B_START = "asm { db 0xEB, 0x08, 0x52, 0x32, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const Decode_Section_B_END   = "asm { db 0xEB, 0x08, 0x52, 0x32, 0x5F, 0x52, 0x44 ,0x45, 0x4E, 0x44; }";

const Decode_Section_C_START = "asm { db 0xEB, 0x08, 0x52, 0x33, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const Decode_Section_C_END   = "asm { db 0xEB, 0x08, 0x52, 0x33, 0x5F, 0x52, 0x44 ,0x45, 0x4E, 0x44; }";

const ZProtect_VM_START      = "asm { db 0xEB, 0x08, 0x56, 0x4D, 0x5F, 0x53, 0x54 ,0x41, 0x52, 0x54; }";
const ZProtect_VM_END        = "asm { db 0xEB, 0x08, 0x56, 0x4D, 0x5F, 0x56, 0x4D ,0x45, 0x4E, 0x44; }";
                                    
}


// How to use:
 
/*
 * Example:
 *
 * mixin(ZProtect_VM_START);
 *
 * for (int i = 0; i < 100; i++)
 * {
 *     value += value * i + 3;
 * }
 *
 * mixin(ZProtect_VM_END);
 *
 *
 */
